' AutoIndex.bas for FilmStar DESIGN
' Copyright 2011 FTG Software Associates
'
' This program determines n,k function coefficients
Option Explicit
Const Archive$ =  "TiO2 Chamber_1.faw"       ' FILM Archive
Const Spectrum$ = "TiO2_Chamber_1.dx"        ' Measured spectrum
Const Indices$ =  "Oxides_Chamber_1.inw"     ' Film Indices file
Sub Main
    PlotClose   ' in case FSPlot Module open
    FileOpen Archive$
    FileOpen Spectrum$
    DataConvert: PlotActivate: PlotNext
    SpecTargets True, "T", 1, 0, "P"   ' Convert spectrum to targets
    StatusLabel "Estimating thickness"
    BasChain "C:\Winfilm\Basic32\ThickSolve.bas"
    StatusLabel "Optimizing"
    Optimize   ' Refine thickness and n,k function coefficients
    StatusLabel ""
    Calculate: PlotNext    ' Visually compare 
    If MsgBox ("Merit = " & Format$(Merit, "0.00") & "; Save Film Indices?", _
      vbYesNo + vbQuestion, "Accept Results") = vbYes Then
        If FileExists(Indices$) Then Kill Indices$
        FileSave Indices$
    End If   
End Sub
Function FileExists(ByVal f$) As Boolean
    On Error GoTo NoFile
    FileExists = (FileLen(f$) > 0)
    Exit Function
NoFile:
    FileExists = False
    Exit Function
End Function