' BandWidthTable.bas for FilmStar DESIGN
' Copyright 1995-2010 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Plots graph showing max, center and half width in table
' Based on BandWidthPlot.bas
'
'    *************************************************
'    Use this example with FILM Archive Fnum-Table.faw
'    *************************************************
'
' If the table does not appear in the FSPlot Module, it is probably because
' it was not enabled. Click Setup...Table <Ctrl+B> to enable.
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   BandPass Table
'   Command       basrun c:\Winfilm\Basic32\BandWidthTable.bas;
'
Option Explicit
DefInt I-N
DefSng A-H, O-Z

Sub Main
    Dim k, kFmt, kErr As Boolean, b50, tm, wc, wMin, wMax
    ' Calculate within range wMin, wMax as shown in FilmStar DESIGN screen
    ' This allows the spectral data set to be larger than the displayed axes
    ' when there are several peaks to be considered

    ' *****************************************
    '      Included for new users
    '      Change or delete as required
    FileOpen "Fnum-Table.faw"
    ' *****************************************
    Calculate
    AxesRange wMin, wMax
    BandMax wMin, wMax, tm, kErr
    GraphSetup

    If Not kErr Then BandCtr wMin, wMax, wc, kErr           ' get center
    If Not kErr Then BandWidth 50, wMin, wMax, b50, kErr    ' get halfwidth
    If Not kErr Then
    PlotClose   ' close FSPlot Module

    ' The following code was generated by clicking File...Create BASIC Setup
    ' in the FSPlot Module. Note that "& _" is the line continuation character
    ' PlotTableGrid assigns table: columns TAB separated, lines CRLF separated

    '	PlotTableGrid = "Center  " & vbTab & "wCenter" & vbCrLf & _
	'	"Maximum  " & vbTab & "TrnsMax" & vbCrLf & _
    '	"Halfwidth  " & vbTab & "Trns50%"

    '   Replacing "wCenter" by eFmt$(wc) & " nm"
    '             "TrnsMax" by eFmt$(tm) & "%"
    '             "Trns50%" by eFmt$(b50) & " nm"
    '   we get the following:

        PlotTableGrid = "Center  " & vbTab & eFmt$(wc) & " nm" & vbCrLf & _
        "Maximum  " & vbTab & eFmt$(100*tm) & "%" & vbCrLf & _
        "Halfwidth  " & vbTab & eFmt$(b50) & " nm"

    ' Note also that plot table setup is saved with Graph Axes (DESIGN)
    ' or Scan Method (MEASURE).

        PlotActivate    ' Open FSPlot Module
        PlotNext        ' Plot Data
    Else
        ' You get this error if there is no spectrum available
        Display "----Error----", "Bandwidth Calculation", 6000, 4000, "Arial", 32, 1
    End If
    Busy False
End Sub

Sub GraphSetup
' FSPlot graph setup code for FilmStar BASIC:
    PlotConfig 11088081, 2129, 0
    PlotSize 9500, 8250, 78
    PlotTitleFont = "Arial"
    PlotTitleSize = 120
    PlotLegendSize = 100
    PlotAxesFont = "Arial"
    PlotAxesLabelSize = 100
    PlotAxesNumberSize = 100
    PlotFontFixed = False
    PlotFontFixedSize = 1
    PlotAxesConfig = 0
    PlotEdgeSpace 25, -25, 25, 25
    PlotAxesSpace .15, .3, .3, 1.5
    PlotColors "255, 16711680, 57088, 16711935, 8421376, 32896, 0, 8421504, 128, 8388608, 32768, 8388736"
    ' This example illustrates bitmap mode
    PlotBitmapMode = True
    PlotBitmap(1) = ""
    PlotBitmap(2) = ""
    PlotBitmapType = 2
    PlotBitmapColors 4210752, 9408399, 5197647, 16777215, 16777215, 2039583
    PlotTableColors 8454143, 0, 0, 0
End Sub

Sub AxesRange(wMin, wMax) ' works in DESIGN and MEASURE
    Dim k, s$
    k = Macro("AxesCopy;")
    s$ = Clipboard$()
    k = InStr(s$, vbTab)
    wMin = Val(Mid$(s$, 1, k -1))
    s$ = Mid$(s$, k + 1)
    k = InStr(s$, vbTab)
    wMax = Val(Mid$(s$, 1, k -1))
End Sub

Function eFmt$(v)
    ' Formats for European decimal (replace "," by "`")
    ' "`" is then replaced by "," in the FSPlot Module
    eFmt$ = Replace(Format$(v, "0.00"),",","`")
End Function
