' CARYWIN1.BAS for FilmStar DESIGN, MEASURE
' Copyright 1999-2005 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program converts Varian Cary .csv (Windows) spectra to FilmStar
' DESIGN/MEASURE .csv format. It stores the new file in the default
' Spectra directory (File...Configuration...Directories). It is similar
' to CARYWIN2.BAS which loads the spectrum into FilmStar.
'
' If you have difficulties, check that you Cary .csv file has
' the same format as sample file TA2O5.CSV.
'
' To exit the program, click Cancel in the file name dialog

DefInt I-N
DefSng A-H, O-Z
Dim sType$, dName$, fName$, file$, path$

Sub Main
    If InStr(UCase$(PgmExe), "DES") > 0 Then ' DESIGN                
        path$ = IniString("Files", "Path4")
    Else
        path$ = IniString("Files", "Path2")
    End If  
    If Right$(path$, 1) <> "\" Then path$ = path$ & "\"         
    dName$ = IniString("Varian", "SpcPath")   
    Do ' Continue until Cancel button clicked
        OpenFile
    Loop
End Sub

Sub OpenFile
    file$ = GetFilePath$(, "csv", dName$, "Open Cary spectrum", 0)
    If file$ = "" Then
        WriteIniString "Varian", "SpcPath", dName$
        End
    Else
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)            ' directory
                fName$ = Right$(file$, Len(file$) - i)
                fName$ = Left$(fName$, Len(fName$) - 4) ' file name
                Exit For
            End If
        Next i
        ConvertFile
    End If
End Sub

Sub ConvertFile()
    If fName$ = "" Then Exit Sub
    StatusLabel "Converting " & fName & " - please wait"
    On Error Resume Next
    Open file$ For Input As #1
    Line Input #1, desc$
    desc$ = Left$(desc$, Len(desc$) - 2)
    If Len(desc$) > 50 Then desc$ = Left$(desc$,50)
    Line Input #1, s$   ' Read second line
    Do
        Line Input #1, s$
        If s$ = "" Then Exit Do  ' Blank line is end of data
        k = k + 1
    Loop
    For i =1 To 11
        Line Input #1, s$
    Next i
    ' Last s$ includes Y mode 
    If InStr(s$,"%R") > 0 Then sType$ = "R"
    Close #1
    ReDim sf$(1 To k)
    Open file$ For Input As #1
    Line Input #1, dum$     ' Read first two lines
    Line Input #1, dum$
    For i = 1 To k          ' Read spectrum lines
        Line Input #1, sf$(k - i + 1)
    Next i
    Close #1
    ' The following line stores in FilmStar Spectra directory
    Open path$ & fName$ & ".csv" For Output As # 1
    Write #1, desc$
    Write #1, k
    For i = 1 To k
        Parse sf$(i), dum$, wave, ","
        Parse sf$(i), dum$, spec, ","
        v = spec / 100
        If sType$ = "R" Then
            Write #1, wave, v, 0
        Else
            Write #1, wave, 0, v
        End If
    Next i
    Close #1
    StatusLabel ""
    Busy False
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub
