'#Reference {A518A78A-ECF7-4AD8-AFF1-A7482FEA9A0F}#1.b#0#C:\Winfilm\Index1.exe#FtgIndex1
' FRED2.BAS for FilmStar LT DESIGN 32-bit
' Copyright 2002-2010 FTG Software Associates

' 08.08.10...Initial version based on FRED.bas
'
' Creates coating files for FRED Optical Engineering Software
' (Photon Engineering, Tucson www.photonengr.com
' Please notify FTG Software if there are issues with your
' version of FRED

Option Explicit
Option Base 1

' If there is an error in the next line, it is likely that
' the reference has been lost. Click Edit...References and
' re-establish the reference to FtgIndex1

Public pINDEX As FtgIndex1.clsBasic
DefInt i-N
DefSng A-H, O-Z
'
Public path$
Public Const ext$ = ".dat"             ' extension
' *************************************************************
'
Sub Main
    Dim i, nmats, vdum, file$, des$, nam$, sdum$, tmp$, symb$
    Dim nl, ql(), qt$(), qd$()
    Dim inam$, snam$
    path$ = PgmPath & "\FRED"
    If Not DirExists(path$) Then
        MsgBox "Missing output directory " & path$, vbCritical, "FRED Coating File"
        End
    End If
    tmp$ = FileName(8)      ' FILM Archive name
    On Error GoTo Quit      ' File name
    DesignConvert 1, "N"    ' Optical to physical thickness in nm
    file$ = GetFilePath$(tmp$, Mid$(ext$, 2), path$, "Open FRED Coating File", 3)
    If Trim$(file$) = "" Then End
    Set pINDEX = New FtgIndex1.clsBasic
    tmp$ = InputBox("Enter optional file header", "Header Field", "Created by FilmStar DESIGN")
    Open file$ For Output As #1
    Print #1, "<HEADER>" & vbCrLf & tmp$
    Print #1, "<COATING NAME>" & vbCrLf & FileName(8)
    Print #1, "<DESCRIPTION>" & vbCrLf & FileDescription(8)
    Print #1, "<ANGLE OF INCIDENCE>" & vbCrLf & "0"
    Print #1, "<REFERENCE WAVELENGTH (UNITS ARE NM)>" & vbCrLf & CStr(DesignWave)
    Print #1, "<MATERIALS (UNITS ARE NM, n-ik WHERE k>0 MEANS ABSORPTION CONVENTION>"
    IndexCopy   ' copy Film Indices values to clipboard
    tmp$ = Clipboard$
    Parse tmp$, sdum$, vdum, vbTab
    Parse tmp$, sdum$, vdum, vbTab
    Parse tmp$, inam$, vdum, vbTab    ' in 3rd column
    If inam$="" Or Left$(inam$, 1) = "$" Then    ' incident medium
        MsgBox "No dispersive file for incident medium (AIR)!", vbCritical, "Film Indices"
        GoTo quit
    Else
        Print #1, inam$
        GetNKtable inam$
    End If
	Parse tmp$, sdum$, vdum, vbCrLf
    Parse tmp$, sdum$, vdum, vbTab
    Parse tmp$, sdum$, vdum, vbTab
    Parse tmp$, snam$, vdum, vbTab  ' in 3rd column
    If snam$ = "" Or Left$(snam$, 1) = "$" Then  ' substrate dispersive file
        MsgBox "No dispersive file for substrate (SUB)!", vbCritical, "Film Indices"
        GoTo quit
    Else
        Print #1, snam$
        GetNKtable snam$
    End If
	Parse tmp$, sdum$, vdum, vbCrLf	' skip extra row
	des$ = Design
	Do
		Parse tmp$, sdum$, vdum, vbCrLf
        Parse tmp$, symb$, vdum, vbTab
        If InStr(des$, symb$) > 0 Then
    		Parse tmp$, sdum$, vdum, vbTab
            Parse tmp$, nam$, vdum, vbTab     ' in 3rd column
			If nam$="" Or Left$(nam$, 1) = "$" Then
                MsgBox "No dispersive file corresponding to index symbol " & symb$ &"!", vbCritical, "Film Indices"
        		GoTo quit
			Else
				Print #1, nam$
                GetNKtable nam$
            End If
    	Else
			Parse tmp$, sdum$, vdum, vbCrLf
    	End If
	Loop Until tmp$=""
	Print #1, "<INCIDENT MEDIUM>"
    Print #1, inam$
	Print #1, "<SUBSTRATE>"
    Print #1, snam$
    Print #1, "<LAYERS (FROM INCIDENT MEDIUM TO SUBSTRATE, UNITS ARE NM, THICKNESSES ARE NORMAL TO SUBSTRATE)>
    GetLayers nl, ql(), qt$(), qd$(), 1
    For i = nl To 1 Step -1  ' FRED layer 1 next to entrance medium
        Print #1, Format$(ql(i)) & vbTab & qd(i)
    Next i
    MsgBox "Coating file " & file$ & " saved successfully", vbInformation, "Export to FRED"

Quit:  Busy False           ' remove hourglass cursor
    Set pINDEX = Nothing    ' release object
    Close #1
    End
End Sub

Sub GetNKtable(ByVal nam$)
    Dim i, s$
    With pINDEX
        .IndexOpen nam$
        s$ = .IndexList(vbTab)
        Print #1, s$
    End With
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub

Function DirExists(ByVal DName$) As Boolean
    Dim s$
    On Error Resume Next
    If Right(DName, 1) <> "\" Then DName = DName & "\"
    s$ = Dir$(DName & "*.*", vbDirectory)
    DirExists = (s$ <> "")
End Function
