' ExcelRandLB.bas for FilmStar DESIGN
' Copyright 2014-2020 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program saves tolerancing results in Excel
' LB indicates 'late binding' - insensitive to Excel version
Option Explicit
Option Base 1
DefInt I-N
DefSng A-H, O-Z

' ******************************************************
'                Modify as required
Const nIter = 10    ' number of iterations
Const xlFile$ = "c:\Winfilm\Excel 2007\RandData.xlsx"
' ******************************************************

Dim xlApp As Object
Dim xlBook As Object
Dim xlSpectra As Object
Dim xlLayers As Object

Sub Main()
    Dim Iter, iDat, nDat, des0$, xDat(), yDat()
    Dim iLay, nLay, q(), qd$(), qt$(), kType
    ' ***************************************************************
    ' Using 'late ginding' independent of Excel version
    ' Does not need Microsoft Excel Object Library
    ' ***************************************************************
    Set xlApp = CreateObject("Excel.Application")
    Set xlBook = xlApp.Workbooks.Open(xlFile$)
    Set xlSpectra = xlBook.Worksheets.Item("Spectra")
    Set xlLayers = xlBook.Worksheets.Item("Layers")
    If AxesYType = "R" Then kType = 1 Else kType = 2
    des0$ = Design  ' save original design
    For Iter = 1 To nIter
        StatusLabel "Iteration " & CStr(Iter) & "/" & CStr(nIter)
        CalcRand , 1    ' retain randomized design
        If Iter = 1 Then
            xDat = Spectrum_X
            nDat = UBound(xDat)
            For iDat = 1 To nDat
                xlSpectra.Cells(iDat + 1, 1) = xDat(iDat)
            Next iDat
        End If
        xlSpectra.Cells(1, Iter+1) = Iter
        yDat = Spectrum_Y
        For iDat = 1 To nDat
            xlSpectra.Cells(iDat + 1, Iter + 1) = yDat(iDat, kType)
        Next iDat
        xlLayers.Cells(1, Iter + 1) = Iter
        GetLayers nLay, q(), qt$(), qd$()
        For iLay = 1 To nLay
            If Iter = 1 Then xlLayers.Cells(iLay + 1, 1) = iLay
            xlLayers.Cells(iLay + 1, Iter + 1) = CStr(q(iLay)) & qt$(iLay)
        Next iLay
        Design = des0$  ' restore original design
    Next Iter
    xlApp.Visible = True    ' Display Excel
    AppActivate "RandData.xlsx"
    StatusLabel ""
    Set xlApp = Nothing
    Set xlBook = Nothing
    Set xlSpectra = Nothing
    Set xlLayers = Nothing
End Sub




