' FA_Secure.bas for FilmStar DESIGN
' Copyright 2010 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************

' Copies FILM Archive to Secure subdirectory

' To run as a macro, insert following under Evaluate..Macro..Edit
' (adjusting if your Winfilm directory is different)
'
'   Description   FA Secure Save
'   Command       basrun C:\Winfilm\Basic32\FA_Secure.bas;

Option Explicit
Option Base 1

' ******************************************************
'                 Adjust as required

Const SecTop$ = "C:\Winfilm\Secure" ' security directory

Const FA_ReadOnly = True    ' set FILM Archive read-only
Const NK_ReadOnly = True    ' set Index Tables read-only
' ******************************************************

Const FASec$ = "Secure FILM Archive"
Dim SecDir$

Sub Main
    CheckOK
    SetDirectory
    CopyFiles
End Sub

Sub CheckOK
    If Not ArchiveMode Then
        MsgBox "FILM Archive mode required", vbCritical, FASec$
        End
    Else
        If ArchiveNK Then
            MsgBox "Does not support Archive n,k mode!", vbCritical, FASec$
            End
        End If
    End If
    If Not DirExists(SecTop$) Then MkDir SecTop$
    If IsBlank(FileName(8)) Then
        MsgBox "No FILM Archive referenced!", vbCritical, FASec$
        End
    End If
    If Not FileExists(FilePath(8) & "\" & FileName(8) & ".faw") Then
        MsgBox "Cannot find FILM Archive" & vbCrLf & FileName(8), vbCritical, FASec$
        End
    End If
    If Right$(PgmCaption, 1) = "*" Then
        MsgBox "(Re)save FILM Archive and run macro again.", vbExclamation, FASec$
        End
    End If
End Sub

Sub SetDirectory
    Dim p$
    SecDir$ = InputBox("Specify subdirectory for FILM Archive" & vbLf & vbLf & FileName$(8), FASec$)
    If SecDir$ <> "" Then
        p$ = SecTop$ & "\" & SecDir$
        If MsgBox("Copy FILM Archive (.faw) and Index Table (*.itw) files to directory" & vbLf & vbLf & p$ & "?", vbYesNo + vbQuestion, FASec$) = vbYes Then
            If DirExists(p$) Then
                If MsgBox("Subdirectory " & p$ & " already exists!" & vbLf & vbLf & "Copy files anyway?", vbYesNo + vbQuestion + vbDefaultButton2, FASec$) = vbNo Then
                    End
                Else
                    MsgBox "Only new files will be copied", vbInformation, FASec$
                End If
            Else
                MkDir p$
                If FA_ReadOnly Or NK_ReadOnly Then SetAttr p$, vbReadOnly
            End If
        Else
            End
        End If
    Else
        End
    End If
End Sub

Sub CopyFiles
    Dim Symb$(), nTyp$(), File$(), Desc$()
    Dim i%, f$, p$, k%
    On Error GoTo CopyErr
    f$ = "\" & FileName$(8) & ".faw"
    p$ = SecTop$ & "\" & SecDir$
    If Not FileExists(p$ & f$) Then
        FileCopy FilePath$(8) & "\" & FileName(8) & ".faw", p$ & f$
        k = 1
        If FA_ReadOnly Then SetAttr p$ & f$, vbReadOnly
    End If
    GetIndexList Symb$(), nTyp(), File$(), Desc$()
    For i = 1 To UBound(Symb$)
        If File$(i) <> "" Then
            If Left$(File$(i), 1) <> "$" Then
                f$ = "\" & File$(i) & ".itw"
                If Not FileExists(p$ & f$) Then
                    FileCopy FilePath$(3) & f$, p$ & f$
                    k = k + 1
                    If NK_ReadOnly Then SetAttr p$ & f$, vbReadOnly
                End If
			End If
		End If
    Next i
    If k = 0 Then
        MsgBox "No files were copied.", vbInformation, FASec$
    Else
        MsgBox CStr(k) & " files were copied.", vbInformation, FASec$
    End If
    Exit Sub
CopyErr:
    MsgBox Err.Description, vbCritical, FASec$
End Sub

Function FileExists(ByVal f$) As Boolean
    On Error GoTo NoFileFound
    If IsBlank(f$) Then
        FileExists = False
    Else
        FileExists = (FileLen(f$) > 0)
    End If
    Exit Function
NoFileFound:
    FileExists = False
    Exit Function
End Function

Function IsBlank(ByVal a$) As Boolean
    If Len(a$) = 0 Then
        IsBlank = True
    Else
        Dim b$
        b$ = Trim$(a$)
        If Len(b$) = 0 Then
            IsBlank = True
        Else
            If Asc(Mid$(b$, 1, 1)) > 32 Then
                IsBlank = False
            Else
                IsBlank = True
            End If
        End If
    End If
End Function

Function DirExists(ByVal DName$) As Boolean
    Dim sdum$
    On Error Resume Next
    If Right(DName, 1) <> "\" Then DName = DName & "\"
    sdum = Dir$(DName & "*.*", vbDirectory)
    DirExists = Not IsBlank(sdum)
End Function
