' FNum32Bold.bas for FilmStar DESIGN 32 bit
' Copyright 1995-1998 FTG Software Associates
' 11/24/00...Replace k=macro() functions with BASIC equivalents
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Same as FNum32.bas except dialog box has bold fonts
' Note call to DeleteObject in Sub Main
'
' Use with FILM Archive FNUM.
' This program simulates the performance of a filter in a convergent
' light beam with uniform illumination and given f-number. It does this
' by repeating the calculation over an angle range and averaging.
'
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   F Number
'   Command       basrun c:\winfilm\basic\f number.bas;
'
Option Explicit
DefInt I-N
DefSng A-H, O-Z
Public Fnum, nRes

' Following used to change font in dialog box
Const LOGPIXELSY = 90
Const WM_SETFONT = &H30
Declare Function CreateFontA Lib "gdi32" (ByVal nHeight As Long, ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, ByVal fnWeight As Long, ByVal fdwItalic As Long, ByVal fdwUnderline As Long, ByVal fdwStrikeOut As Long, ByVal fdwCharSet As Long, ByVal fdwOutputPrecision As Long, ByVal fdwClipPrecision As Long, ByVal fdwQuality As Long, ByVal fdwPitchAndFamily As Long, ByVal lpszFace As String) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Declare Function GetDlgItem Lib "user32" (ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long
Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Declare Function SendMessageA Lib "user32" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim hFont As Long

Sub Main
    On Error GoTo MainEnd
    Do
        GetAngle
        Evaluate
    Loop
MainEnd:
    DeleteObject hFont
    End
End Sub

Sub GetAngle  ' dialog box for entering f number and resolution
    ' On Error GoTo Quit   ' cancel button causes error
    ' Highlight the lines Begin Dialog...End Dialog and activate the
    ' built-in dialog editor. The dialog box will appear in the editor

    Begin Dialog UserDialog 372, 94, "Enter values", .DlgFunc
        Text 27, 23, 73, 13, "&F Number", .lblFnum
        Text 20, 58, 81, 13, "&Resolution", .lblRes
        TextBox 110, 20, 80, 18, .txtFnum
        TextBox 110, 55, 80, 18, .txtRes
        OKButton 250, 19, 88, 21, .cmdOK
        CancelButton 250, 54, 88, 21, .cmdCancel
    End Dialog
    Dim dlg As UserDialog
    If Fnum = 0 Then Fnum = 1.4
    If nRes = 0 Then nRes = 10
    dlg.txtFnum=CStr(Fnum)
    dlg.txtRes=CStr(nRes)
C1:
    Dialog dlg
    Fnum=Val(dlg.txtFnum)
    If Fnum < .5 Then
        Beep
        MsgBox "Must be > 0.5", 48, "FNUM.BAS"
        GoTo C1
    End If
    nRes=Val(dlg.txtRes)
    If nRes < 1 Then
        Beep
        MsgBox "Must be > 0", 48, "FNUM.BAS"
        GoTo C1
    End If
    Exit Sub
Quit:
    End
End Sub

Private Function DlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
    Select Case Action%
    Case 1 ' Dialog box initialization
        SetBold "lblFnum", SuppValue
        SetBold "lblRes", SuppValue
        SetBold "txtFnum", SuppValue
        SetBold "txtRes", SuppValue
        SetBold "cmdCancel", SuppValue
        SetBold "cmdOK", SuppValue
    Case 2 ' Value changing or button pressed
    Case 3 ' TextBox or ComboBox text changed
    Case 4 ' Focus changed
    Case 5 ' Idle
    Case 6 ' Function key
    End Select
End Function

Sub Evaluate   ' Does the calculation
    Dim xdata(), ydata(), ytmp(), yd()
    Dim j, k, n, nData, a, delR, rMax, wJ, wTot
    AxesDraw
    CalcPlotStart
    LineColor "B"
    a=1/(2*Fnum)
    rMax = Tan(Atn(a/Sqr(1-a^2)))   ' asin(a)
    delR = rMax/nRes
    Pol = "R"  ' random polarization
    For n = 1 To nRes
        StatusLabel "Iteration " & CStr(n)
        Angle = 57.29578 * Atn(Sqr(((delR*n)^2 + (delR*(n-1))^2)/2))
        wJ = ((delR*n)^2 - (delR*(n-1))^2)/rMax^2  ' uniform illumination
        wTot = wTot + wJ
        CalcPlot
        ydata = Spectrum_Y ' Get spectrum
        nData = UBound(ydata, 1)
        If n = 1 Then ReDim yd(1 To nData, 2)
        For j = 1 To nData
            yd(j, 1) = yd(j, 1) + wJ * ydata(j, 1)
            yd(j, 2) = yd(j, 2) + wJ * ydata(j, 2)
        Next j
    Next n
    For j = 1 To nData
        ydata(j, 1) = yd(j, 1) / wTot   ' Reflectance
        ydata(j, 2) = yd(j, 2) / wTot   ' Transmittance
    Next j
    Spectrum_Y = ydata  ' Let spectrum
    LineColor "R"
    Replot
    CalcPlotDone
End Sub

Private Function SetBold(ByVal item$, ByVal SuppValue&)
    Dim hDC&, hWnd&, Height&
    Static k As Boolean
    If Not k Then
        hDC = GetWindowDC(0)
        Height = -8 * GetDeviceCaps(hDC,LOGPIXELSY) / 72   ' 8 point
        ReleaseDC 0, hDC
        hFont = CreateFontA(Height,0,0,0,700,0,0,0,0,0,0,0,0,"MS Sans Serif")  ' bold, MS Sans Serif
        k = True
    End If
    hWnd = GetDlgItem(SuppValue, DlgControlId(item$))
    SendMessageA hWnd, WM_SETFONT, hFont, 1
End Function
