' Program IndexTempVar.bas for FilmStar INDEX
' Copyright 2009 FTG Software
' Applies thermo-optic coefficient to n values

' NOTE: This model assumes a constant index dn/dT
'       variation with temperature deviation from 23C

Option Base 1
Option Explicit
DefInt i-N
DefSng A-H, O-Z
Public fName$
Public Coeff

Sub Main
    Dim s$
    Const Title$ = "Index Adjust"
    On Error Resume Next
    fName$ = IndexName$
    If fName$ <> "" Then
        Coeff = Val(InputBox(fName$ & " thermo-optic coefficient?", Title$, s$))
        If MsgBox("Apply T-O coefficient " & Format$(Coeff, "0.00E+0") & " to index table " _
           & fName$ & "?",vbQuestion + vbYesNo, Title$) = vbYes Then
            If nIndex > 0 Then
                TableModify
                MsgBox "New files (+40C, -10C) saved",vbInformation, Title$
            Else
                MsgBox "Unsuccessful operation",vbExclamation, Title$
            End If
        End If
    Else
        MsgBox "No index file specified", vbExclamation, Title$
    End If
End Sub

Sub TableModify
    Dim i
    ReDim xIndx(1, 1)
    xIndx = nkTable
    ' original index tables at 23C (room temperature)
    For i = 1 To nIndex
        ' increase 17C
        xIndx(i, 2) = xIndx(i, 2) + 17 * Coeff  ' + 40C
    Next i
    nkTable = xIndx
    FileSave fName$ & " +40C"

    For i = 1 To nIndex
        ' decrease -50C
        xIndx(i, 2) = xIndx(i, 2) - 50 * Coeff  ' - 10C
    Next i
    nkTable = xIndx
    FileSave fName$ & " -10C"
End Sub

