' LuxpopNK.bas for FilmStar INDEX
' Copyright 2010 FTG Software Associates

' Imports refractuve index tables from
' http://www.luxpop.com/RefractiveIndexList.html

' Right click NK link and save in directory Path$

Const Path$ = "C:\Winfilm\LuxpopNK"

Option Explicit
Option Base 1
DefInt i-N
DefSng A-H, O-Z

Sub Main
    Dim i, kMult, kFN, File$, lin$, s$, mess$, isAngs As Boolean
    Dim xdum, dum$
    File$ = GetFilePath(, "nk", Path$, "Open Luxpop n,k File")
    If Len(File$) > 0 Then
        On Error GoTo OpenError
        kFN = FreeFile
        Open File$ For Input As #kFN
        Line Input #kFN, s$
        s$ = Replace(s$,vbLf,vbCrLf)
        Close #kFN

        Display s$, "File Viewer - click <Close> to proceed", 9000, 4500, "Verdana", 10, 0
        If MsgBox("Continue to import file?", vbQuestion + vbYesNo, "Luxpop n,k") = vbNo Then End

        isAngs = InStr(s$, "(A)" ) > 0
        If Not isAngs Then kMult = Val(InputBox("Wavelength multiplier? (nm = 1, um = 1000)", "Luxpop n,k", "1"))

        s$ = Mid$(s$, InStr(s$, "-----" & vbCrLf) + 7) ' get to numeric array
        Do While Len(Trim$(s$)) > 0
            i = i + 1
            Parse s$, lin$, xdum, vbCrLf
            lin$ = Trim$(lin$)
            ReDim Preserve wave(i), xn(i), xk(i)
            Parse lin$, dum$, wave(i), " "
            Parse lin$, dum$, xn(i), " "
            Parse lin$, dum$, xk(i), " "
        Loop

        ReDim xindx(i, 3)
        For i = 1 To UBound(xindx, 1)
            xindx(i, 1) = wave(i)
            If isAngs Then
                xindx(i, 1) = .1* wave(i)       ' convert to nm
            Else
                xindx(i, 1) = kMult * wave(i)   ' convert to nm
            End If
            xindx(i, 2) = xn(i)
            xindx(i, 3) = xk(i)
        Next i
        nkTable= xindx  ' assign to INDEX variables
        AutoAxes True
        IndexName$ = FileName$(File$) & " Luxpop"
        FileSave
    End If
    Exit Sub
OpenError:
    Close #kFN
    MsgBox Err.Description, vbCritical, "File Open Error"
End Sub

Function FileName$(ByVal f$)
    Dim k, r$
    r$ = StrReverse(f$)
    k = Len(f$) - InStr(r$, "\") + 1
    FileName$ = Mid$(f$, k + 1)
    FileName$ = Left$(FileName$, Len(FileName$) - 3)
End Function

Sub Parse(StrIn$, StrOut$, xout As Variant, delim$)
    On Error Resume Next
    Dim i
    StrIn$ = Trim$(StrIn$)
    i = InStr(StrIn$, delim$)
    If i > 0 Then
        StrOut$ = LTrim$(Mid$(StrIn$, 1, i - 1))
        StrIn$ = Mid$(StrIn$, i + Len(delim$))
    Else
        StrOut$ = StrIn$
        StrIn$ = ""
    End If
    xout = Val(StrOut) ' Decimal must always be "."
End Sub
