' MonitorWidth2.bas for FilmStar DESIGN
' Copyright 2012-2013 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Adds monochromator bandwidth to R/T vs thickness (monitor) calculations
' Illustrates how FSPlot Module can average a series of spectra
' MonitorWidth1.bas is more direct and faster, but not as entertaining.
'
' To run this program As a Macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   Monitor Bandwidth
'   Command       basrun c:\winfilm\basic32\MonitorWidth2.bas;

Option Base 1
Public wh!
Option Explicit

Sub Main
    On Error Resume Next    ' in case Cancel pushed
    If MsgBox("Reset FSPlot configuration?", vbYesNo + vbDefaultButton2, "Monitor Bandwidth") = vbYes Then
        PlotClose
        PlotSetup
    End If
    wh = Val(IniString("Monochromator", "Bandwidth"))
    If wh = 0 Then wh = 5
    wh = Val(InputBox("50% bandwidth in nm?", "Monochromator Simulation", CStr(wh)))
    If wh > 0 Then
        HighRes   ' low + high + monochromatic
        WriteIniString "Monochromator", "Bandwidth", CStr(wh)
    End If
End Sub

Sub HighRes	' 13 points
    Dim i, w!, z!, s$
    PlotClose
    PlotLegendOn False
    PlotTitle = "Optical Monitor Simulation"
    PlotActivate
    w! = EvalWave
	For z = w - 1.5*wh To w + 1.5*wh Step wh/4
		EvalWave = z
		Calculate
		PlotNext
	Next z
    s$ = "B=(.002*(B+N) + .0131*(C+M) + .0625*(D+L) + .2102*(E+K) + .5*(F+J) + .8409*(G+I) + H)/4.2574;"
	For i = 78 To 67 Step -1
		s$ = s$ & "del " & Chr$(i) & ";"
	Next i
    PlotRun s$
    EvalWave = w
    Calculate
    PlotLegend(1) = "Bandwidth = " & CStr(wh) & " nm"
    PlotLegend(2) = "Monochromatic"
    PlotLegendOn True
    PlotNext
End Sub

Sub PlotSetup
    ' FSPlot graph setup code for FilmStar BASIC:
    PlotConfig 25526465, 2128, 0
    PlotSize 12720, 7590, 74
    PlotTitleFont = "Verdana"
    PlotTitleSize = 110
    PlotLegendSize = 100
    PlotLegendSimple = False
    PlotAxesFont = "Verdana"
    PlotAxesLabelSize = 100
    PlotAxesNumberSize = 100
    PlotFontFixed = False
    PlotFontFixedSize = 1
    PlotAxesConfig = 0
    PlotEdgeSpace 50, -25, 20, 30
    PlotAxesSpace .15, .3, .3, 1.5
    PlotColors "255, 16711680, 57088, 16711935, 8421376, 32896, 0, 8421504, 128, 8388608, 32768, 8388736"
    PlotBitmapMode = False
End Sub
