' QAreportEx.bas for FilmStar DESIGN and MEASURE
' Copyright 2021 FTG Software Associates
' An example to be modified and expanded by users.
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Functions used to change font in dialog box from default MS Sans Serif (hard to read)
Const LOGPIXELSY = 90
Const WM_SETFONT = &H30
Declare Function CreateFontA Lib "gdi32" (ByVal nHeight As Long, ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, ByVal fnWeight As Long, ByVal fdwItalic As Long, ByVal fdwUnderline As Long, ByVal fdwStrikeOut As Long, ByVal fdwCharSet As Long, ByVal fdwOutputPrecision As Long, ByVal fdwClipPrecision As Long, ByVal fdwQuality As Long, ByVal fdwPitchAndFamily As Long, ByVal lpszFace As String) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Declare Function GetDlgItem Lib "user32" (ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long
Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Declare Function SendMessageA Lib "user32" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim hFont As Long
Option Base 1
Option Explicit

Sub Main
    If MsgBox("Does the scan look OK?", vbYesNo+vbQuestion, "QA Report") = vbYes Then CreateReport
End Sub

Sub CreateReport
    Dim Specs$(4), kSpec%, wMin!, wMax!, Lot$, s$, t$
    Dim yMin!, yMax!, yAve!
    Const Sec$ = "QAreportEx"   ' Section name for saved settings
    Begin Dialog UserDialog 440,196,"Enter values",.DlgFunc ' %GRID:10,7,1,1
        PushButton 170,154,110,28,"OK",.cmdOK
        Text 80,21,60,14,"LOT #",.Text1,1
        Text 50,51,90,14,"Range (nm)",.Text2,1
        TextBox 150,18,200,18,.txtLot
        TextBox 150,51,60,15,.txtWmin
        TextBox 230,51,60,15,.txtWmax
        ListBox 100,77,250,70,Specs(),.lstSpec
    End Dialog
    Specs(1) = "BBAR"
    Specs(2) = "HIREFL"
    Specs(3) = "VCOAT"
    Specs(4) = "GREEN"
    Lot$ = IniString(Sec$, "LotNum")
    wMin = Val(IniString(Sec$, "WaveMin"))
    wMax = Val(IniString(Sec$, "WaveMax"))
    kSpec = Val(IniString(Sec$, "SpecType"))
    If wMin = 0 Then wMin = 450: wMax = 750
    Dim dlg As UserDialog
    With dlg
        .txtLot = Lot$
        .txtWmin = CStr(wMin)    ' previous values
        .txtWmax = CStr(wMax)
        If kSpec > 0 Then .lstSpec = kSpec-1
    End With
StartOver:
    Dialog dlg
    With dlg
        Lot$ = .txtLot
        kSpec = .lstSpec + 1
        wMin = Val(.txtWmin)
        wMax = Val(.txtWmax)
    End With
    WriteIniString Sec$, "LotNum", Lot$
    WriteIniString Sec$, "WaveMin", CStr(wMin)
    WriteIniString Sec$, "WaveMax", CStr(wMax)
    WriteIniString Sec$, "SpecType", CStr(kSpec)
    Select Case MsgBox("Coating Lot: " & Lot$ & vbLf & "QA Spec: " & Specs$(kSpec) & vbLf & _
       "Range: " & CStr(wMin) & "nm to " & CStr(wMax) & "nm", vbYesNoCancel, _
       "Yes: PRINT, No: DO OVER, Cancel: QUIT")
    Case vbYes
        Select Case kSpec   ' Specification type
        Case 1
            ' DESIGN
            'GetMinAveMax 1, yMin, yAve, yMax, wMin, wMax    ' Reflectance
            'GetMinAveMax 2, yMin, yAve, yMax, wMin, wMax   ' Transmittance
            ' MEASURE
            AveCalc yMin, yMax, yAve, wMin, wMax
        Case Else
            MsgBox "Undefined specification type!" & vbLf & "Modify BASIC code or contact FTG Software", vbCritical, "FTG Custom Solutions"
            End
        End Select
        PlotSetup: PlotClose: PlotActivate: PlotNext
        ' Use BasText to insert calculated values in Report
        BasText$(0) = "This report generated on " & Split(CStr(Now), " ")(0)
        BasText$(1) = "Need help? Call Fred at +1 609-924-6222!"
        t$ = "<<Align 1>><<Name Verdana>><<Bold 1>><<Size 14>>" & vbCrLf
        t$ = t$ & "Coating Lot: " & Lot$ & vbCrLf & "<<Bold 0>><<Size 12>>" & vbCrLf
        t$ = t$ & "<<FSPlot 100,80,8500,7000>>" & vbCrLf
        t$ = t$ & "Range " & CStr(wMin) & "-" & CStr(wMax) & "nm: "
        t$ = t$ & "Min = " & Format$(yMin, "0.000") & "%    Max = " & Format$(yMax, "0.000") & "%    Ave = " & Format$(yAve, "0.000") & "%" & vbCrLf & vbCrLf
        t$ = t$ & "<<BasText 0>>" & vbCrLf & vbCrLf & "<<Size 15>><<Italic 1>><<BasText 1>>"
        Template$ = t$
        ReportShow
        PlotClose
    Case vbNo
        GoTo StartOver
    Case vbCancel
        End
    End Select
End Sub

Private Function DlgFunc(DlgItem$, Action%, s&) As Boolean
    Select Case Action%
    Case 1 ' Dialog box initialization
        SetBold "cmdOK", s
        SetBold "text1", s
        SetBold "text2", s
        SetBold "txtLot", s
        SetBold "txtWmin", s
        SetBold "txtWmax", s
        SetBold "lstSpec", s
    Case 2 ' Value changing or button pressed
    Case 3 ' TextBox or ComboBox text changed
    Case 4 ' Focus changed
    Case 5 ' Idle
    Case 6 ' Function key
    End Select
End Function

Private Function SetBold(ByVal item$, ByVal SuppValue&)
    ' Optional.. replace MS Sans Serif with more legible font
    Dim hDC&, hWnd&, Height&
    Static k As Boolean
    If Not k Then
        hDC = GetWindowDC(0)
        Height = -9 * GetDeviceCaps(hDC,LOGPIXELSY) / 72   ' 9 point
        ReleaseDC 0, hDC
        hFont = CreateFontA(Height,0,0,0,300,0,0,0,0,0,0,0,0,"Arial Rounded MT Bold")
        k = True
    End If
    hWnd = GetDlgItem(SuppValue, DlgControlId(item$))
    SendMessageA hWnd, WM_SETFONT, hFont, 1
End Function

Sub PlotSetup
' FSPlot graph setup code for FilmStar BASIC:
    PlotConfig 8740937, 102128, 0
    PlotSize 8500, 7000, 80
    PlotTitleFont = "Arial"
    PlotTitleSize = 110
    PlotLegendSize = 110
    PlotLegendSimple = False
    PlotAxesFont = "Arial Rounded MT Bold"
    PlotAxesLabelSize = 110
    PlotAxesNumberSize = 110
    PlotFontFixed = False
    PlotFontFixedSize = 2
    PlotAxesConfig = 0
    PlotEdgeSpace 50, -50, 50, 0
    PlotAxesSpace .15, .25, .5, 1.5
    PlotColors "255, 16711680, 65280, 16711935, 8421376, 32896, 0, 8421504, 128, 8388608, 32768, 8388736"
    PlotBitmapMode = False
    PlotTableColors 16777215, 0, 0, 0
End Sub
