'#Reference {A518A78A-ECF7-4AD8-AFF1-A7482FEA9A0F}#1.f#0#C:\Winfilm\Index1.exe#FtgIndex1
' Spektrum.bas for FilmStar DESIGN exports LZH .dsg files for CEC coaters
' Note that some settings are utilized by Spektrum and not by CEC
' Copyright 2018 FTG Software Associates, revised 01.31.18, 07.26.18
Option Explicit
Option Base 1
DefInt i-N
DefSng A-H, O-Z
Public pIndex As FtgIndex1.clsBasic
Public pMain As FtgIndex1.clsMain
Public Symb$(), nTyp$(), File$(), Desc$(), CecFile$, CecPath$, vRate$
Public Const mTitle$ = "Spektrum (CEC) Design File"

Sub Main
    Dim k, sFile$
    If MsgBox("Export FILM Archive " & FileName(8) & ".faw to .dsg?" & vbLf & vbLf & "If open, close INDEX before proceeding.", _
      vbOkCancel + vbQuestion, mTitle$) = vbCancel Then End
    ' ********* Change as required **********
    '     PgmPath$ is normally C:\Winfilm
    CecPath$ = PgmPath$ & "\Export"
    ' ***************************************
    Set pIndex = New FtgIndex1.clsBasic
    Set pMain = New FtgIndex1.clsMain
    FileSaveAll ' added 07.26.18
    If Not PathExists(CecPath$) Then MkDir CecPath$
    CecFile$ = CecPath$ & "\" & FileName$(8) & ".dsg"
    If FileExists(CecFile$) Then
        Select Case MsgBox(CecFile$ & " already exists!" & vbLf & vbLf &  "Replace it? <No> saves with new name." , _
          vbYesNoCancel + vbExclamation + vbDefaultButton2+ vbQuestion, mTitle$)
        Case vbYes
            Kill CecFile$
        Case vbNo
            Do
                k = k + 1
                sFile$ = Left$(CecFile$, Len(CecFile$)-4) & CStr(k) & ".dsg"
            Loop Until Not FileExists(sFile$)
            CecFile$ = sFile$
        Case vbCancel
            CloseDown
            End
        End Select
    End If
    Open CecFile$ For Output As #1
    GetIndexList  Symb$(), nTyp$(), File$(), Desc$()
    AddDesign
    AddMaterials
    CloseDown
    MsgBox CecFile$ & " saved", vbInformation, mTitle$
End Sub

Sub CloseDown
    On Error Resume Next
    Close #1
    Wait 1
    FileOpenAll
    pMain.Quit
    DoEvents
    Set pIndex = Nothing
    Set pMain = Nothing
End Sub

Sub AddDesign
    Dim iRow, dspFlg As Boolean, s$
    Dim iLay, nLay, sLay$, kInx, qOpt(), qPhs(), qTyp$(), qDsc$(), qTot, nSymb$
    Dim xMin, xMax, xLbl, yMin, yMax, yLbl
    For iRow = 2 To UBound(File$)       ' iRow is row in Film Indices dialog
        If File$(iRow) <> "" Then
            dspFlg=True ' design contains dispersion
            Exit For
        End If
    Next iRow

    For iRow = 3 To UBound(File$)
        nSymb$ = nSymb$ & Symb$(iRow)  ' gives "LH" etc.
    Next iRow

    If dspFlg Then  ' dispersion
        Print #1, "##DISP_PE_STST=1_0_0_0_0 | Spektrum-Version: 31.08.2017"
    Else            ' no dispersion
        Print #1, "##DISP_PE_STST=0_0_0_0_0 | Spektrum-Version: 31.08.2017"
    End If
    Print #1,"##INFO=" & FileName$(8)
    Select Case AxesYType
    Case "R"
        Print #1,"##RT=R"
    Case Else
        Print #1,"##RT=T"
    End Select
    Print #1, "##PHASE=NEIN"
    If TypeSide2 = 2 Then
        Print #1, "##RCKS.=JA"
    ElseIf TypeSide2 =1 Then
        Print #1, "##RCKS.=NEIN"
    Else
        TypeSide2=1
        MsgBox "Setting Spektrum to FWD ignore Side 2", vbInformation, mTitle$
        Print #1, "##RCKS.=NEIN"
    End If
    Select Case Pol$
    Case "P"
        Print #1, "##POL.=p-pol."
    Case "S"
        Print #1, "##POL.=s-pol."
    Case "R"
        Print #1, "##POL.=unpol."
    End Select
    Print #1, "##EINFALLSW.=" & CStr(Angle)
    AxesRange xMin, xMax, xLbl, yMin, yMax, yLbl
    Print #1, "##X-EINHEIT=[nm]"
    Print #1, "##X-MIN[nm]=" & CStr(xMin)
    Print #1, "##X-MAX[nm]=" & CStr(xMax)
    Print #1, "##X_L_STEP=" & CStr(xLbl)
    Print #1, "##Y-EINHEIT=[%]"
    Print #1, "##Y-MIN="& CStr(yMin)
    Print #1, "##Y-MAX="& CStr(yMax)
    Print #1, "##Y_L_STEP=" & CStr(yLbl)
    Print #1, "##SUBSTRATD.=" & CStr(SubThick)
    s$ = Layers$            ' converts groups to layers
    DesignConvert 2, 4      ' optical thickness
    GetLayers nLay, qOpt(), qTyp$(), qDsc$()

    DesignConvert 1, "N"    ' physical thickness
    GetLayers nLay, qPhs(), qTyp$(), qDsc$()

    Print #1, "##OPT.SCHICHTEN=TRUE"
    Print #1, "##PHYS.SCHICHTEN=FALSE"
    Print #1, "##VORDERSEITE" & vbCrLf  ' adds blank line
    Print #1, "##n-MED.=1"      ' incident medium

    If File$(2)="" Then
        Print #1, "##n-SUB.=" & CStr(IndexCoeff(2, 1))  ' constant
    Else
        Print #1, "##n-SUB.=-1" ' dispersive, first material
    End If
    Print #1, "##ZENTRALW.=" & CStr(DesignWave)
    Print #1, "##SCHICHTFOLGE (Nr.,n,d)="
    For iLay = 1 To nLay
        sLay$ = CStr(iLay)
        kInx = 1 + InStr(nSymb$, qTyp$(iLay))
        If File$(1 + kInx) = "" Then
            sLay$ = sLay$ & vbTab & CStr(IndexCoeff(kInx +1, 1))
        Else
            sLay$ = sLay$ & vbTab & CStr(-kInx)
        End If
        Print #1, sLay$ & vbTab & CStr(qOpt(iLay))
    Next iLay

    Print #1, vbCrLf & "##GEOM.SCHICHTFOLGE (Nr.,n,d[nm])="

    For iLay = 1 To nLay
        sLay$ = CStr(iLay)
        kInx = 1 + InStr(nSymb, qTyp$(iLay))
        If File$(1 + kInx) = "" Then
            sLay$ = sLay$ & vbTab & CStr(IndexCoeff(kInx +1, 1))
        Else
            sLay$ = sLay$ & vbTab & CStr(-kInx)
        End If
        qTot = qTot + qPhs(iLay)
        Print #1, sLay$ & vbTab & CStr(qPhs(iLay))
    Next iLay
    Print #1, vbCrLf & "##PHYS.-DICKE=" & CStr(qTot) & " nm" & vbCrLf
    Print #1, "##RCKSEITE" & vbCrLf
    Print #1, "##n-MED.=1"
    Print #1, "##n-SUB.=-1"
    Print #1, "##ZENTRALW.="& CStr(DesignWave)
    Print #1, "##SCHICHTFOLGE (Nr.,n,d)=" & vbCrLf
    Print #1, "##GEOM.SCHICHTFOLGE (Nr.,n,d[nm])=" & vbCrLf
    Print #1, "##PHYS.-DICKE=0 nm" & vbCrLf
End Sub

Sub AddMaterials
    Dim iRow, kRate, d$
    For iRow = 2 To UBound(File$)   ' adds substrate index first
        If iRow = 2 Then
            Print #1, "##MATERIAL 1 von " & CStr(UBound(File$) - 1)
        Else
            Print #1, "##MATERIAL " & CStr(iRow-1)
        End If
        d$ = Trim$(Desc$(iRow))
        kRate = InStr(UCase$(d$), "R=")
        If kRate > 0 Then
            vRate$ = Mid$(d$, kRate + 2)
            Print #1, "##TITLE=" & Mid$(d$, 1, kRate-2)
        Else
            vRate$ = "0"
            Print #1, "##TITLE=" & d$
        End If
        If File$(iRow)="" Then
            Print #1, "##INFO= n=" & CStr(IndexCoeff(iRow, 1))
        ElseIf Left$(File$(iRow), 1) = "$" Then
            Print #1, "##INFO=" & Mid$(File$(iRow), 2)
        Else
            Print #1, "##INFO=" & File$(iRow) & ".itw"
        End If
        Print #1, "##G_BEREICH=0 0"
        If File$(iRow) = "" Then  ' nondispersive index
            NoSellmeier
            NoCauchy
            NoOscillator
            NoKformula
            Print #1, "##RATE=" & vRate$
            Print #1, "##K_WERTE=FALSE"
            Print #1, "##NPOINTS=1"     ' nondisperive
            Print #1, "##DATEN(L_n_k)="
            Print #1, "295" & vbTab & CStr(IndexCoeff(iRow, 1)) & vbTab & "0" & vbCrLf
        ElseIf Left$(File$(iRow), 1) = "$" Then   ' index function
            Select Case File$(iRow)
            Case "$CE-CY6", "$CE-CY6K"
                AddCauchy IndexCoeff(iRow, 1), IndexCoeff(iRow, 2), IndexCoeff(iRow, 3), _
                  IndexCoeff(iRow, 4), IndexCoeff(iRow, 5), IndexCoeff(iRow, 6)
                NoTable iRow
            Case "$CE-SM6", "$CE-SM6K
                AddSellmeier IndexCoeff(iRow, 1), IndexCoeff(iRow, 2), IndexCoeff(iRow, 3), _
                  IndexCoeff(iRow, 4), IndexCoeff(iRow, 5), IndexCoeff(iRow, 6)
                NoTable iRow
            Case Else' User-Defined Function
                If FunctionCode$ <> "N1,A*EXP(B/WM+C*WM)" Then   ' Spektrum (CEC) k-Formula code
                    MsgBox "User-Defined Function " & Mid$(File(iRow), 2) & " is not Spektrum compatible", vbCritical, mTitle$
                    CloseDown
                    End
                End If
                NoSellmeier
                NoCauchy
                NoOscillator
                AddKformula IndexCoeff(iRow, 1), IndexCoeff(iRow, 2), IndexCoeff(iRow, 3)
                AddNKtable2 UserIndxTbl$(1, Mid$(File$(iRow), 2))
            Case Else
                MsgBox "Built-in Index Function " & Mid$(File(iRow), 2) & " is not Spektrum compatible", vbCritical, mTitle$
                CloseDown
                End
            End Select
        Else
            AddNKtable1 File$(iRow)     ' dispersive table, no functions
        End If
        DoEvents
    Next iRow
    Exit Sub
End Sub

Sub NoTable(ByVal i)
    If InStr(File$(i), "K") = 0 Then
        NoKformula
    Else
        AddKformula IndexCoeff(i, 7), IndexCoeff(i, 8), IndexCoeff(i, 9)
    End If
    Print #1, "##RATE=" & vRate$
    If InStr(File$(i), "K") = 0 Then
        Print #1, "##K_WERTE=FALSE"
    Else
        Print #1, "##K_WERTE=K-FORMULA"
    End If
    Print #1, "##NPOINTS=0"
    Print #1, "##DATEN(L_n_k)=" & vbCrLf   ' add blank line
End Sub

Sub AddNKtable1(ByVal f$)
    Dim i, s$, nVals, vnk!(), isAbs As Boolean
    If f$ = "" Then Exit Sub
    NoSellmeier
    NoCauchy
    NoOscillator
    NoKformula
    Print #1, "##RATE=" & vRate$
    With pIndex
        s$ = .UUID
        .IndexOpen f$
        vnk = .nkTable
        DoEvents
        For i=1 To UBound(vnk, 1)
            If vnk(i, 3) > 0 Then
                isAbs = True
                Exit For
            End If
        Next i
        If isAbs Then
            Print #1,"##K_WERTE=TABLE"
        Else
            Print #1,"##K_WERTE=FALSE"
        End If
        Print #1, "##NPOINTS=" & CStr(.nIndex)
        Print #1, "##DATEN(L_n_k)="
        Print #1, .IndexList(vbTab, 1) & vbCrLf
    End With
End Sub

Sub AddNKtable2(ByVal f$)
    Dim i, s$, nVals, vnk!(), isAbs As Boolean
    If f$ = "" Then Exit Sub
    Print #1, "##RATE=" & vRate$
    With pIndex
        .IndexOpen f$
        vnk = .nkTable
        DoEvents
        Print #1, "##K_WERTE=K-FORMULA"
        Print #1, "##NPOINTS=" & CStr(.nIndex)
        Print #1, "##DATEN(L_n_k)="
        Print #1, .IndexList(vbTab, 1) & vbCrLf
    End With
End Sub

Sub AddKformula(ByVal B1, ByVal B2, ByVal B3)
    Print #1, "##K-KOEFF="
    Print #1, CStr(B1)
    Print #1, CStr(B2)
    Print #1, CStr(B3)
End Sub

Sub AddCauchy(ByVal A0, ByVal A1, ByVal A2, ByVal A3, ByVal A4, ByVal A5)
    Dim i
    NoSellmeier
    Print #1, "##CAUCHY-KOEFF=TRUE"
    Print #1, CStr(A0)
    Print #1, CStr(A1)
    Print #1, CStr(A2)
    Print #1, CStr(A3)
    Print #1, CStr(A4)
    Print #1, CStr(A5)
    NoOscillator
End Sub

Sub AddSellmeier(ByVal B1, ByVal B2, ByVal B3, ByVal C1, ByVal C2, ByVal C3)
    Print #1, "##SM-KOEFF=TRUE"
    Print #1, CStr(B1) & vbTab & CStr(C1)
    Print #1, CStr(B2) & vbTab & CStr(C2)
    Print #1, CStr(B3) & vbTab & CStr(C3)
    NoCauchy
    NoOscillator
End Sub

Sub NoSellmeier
    Dim i
    Print #1, "##SM-KOEFF=FALSE"
    For i=1 To 3
        Print #1, "0" & vbTab & "0"
    Next i
End Sub

Sub NoCauchy
    Dim i
    Print #1, "##CAUCHY-KOEFF=FALSE"
    For i=1 To 6
        Print #1, "0"
    Next i
End Sub

Sub NoOscillator
    Dim i
    Print #1, "##OM-KOEFF=FALSE"
    For i=1 To 3
        Print #1, "0" & vbTab & "0" & vbTab & "0"
    Next i
End Sub

Sub NoKformula
    Dim i
    Print #1, "##K-KOEFF="
    For i=1 To 3
        Print #1, "0"
    Next i
End Sub

Function SMeval(ByVal W, ByVal B1, ByVal C1, ByVal B2, ByVal C2, ByVal B3, ByVal C3)
    ' Test routine, not utilized in dsg file
    ' Sellmeier...same as SELLG glass formula
    Dim W2
    W = .001*W
    W2 = W*W
    SMeval = Sqr(1 + B1*W2/(W2-C1) + B2*W2/(W2-C2) + B3*W2/(W2-C3))
End Function

Function CYeval(ByVal W, ByVal A0, ByVal A1, ByVal A2, ByVal A3, ByVal A4, ByVal A5)
    ' Test routine, not utilized in dsg file
    ' Cauchy...usually only 2-3 terms are required
    W = .001 * W
    CYeval = A0 + A1/W^2 + A2/W^4 + A3/W^6 + A4/W^8 + A5/W^10
End Function

Function PathExists(ByVal d$) As Boolean
    Dim sdum$
    On Error Resume Next
    If Trim$(d$) <> "" Then
        If Right(d$, 1) <> "\" Then d$ = d$ & "\"
        sdum$ = Dir$(d$ & "*.*", vbDirectory)
        PathExists = (sdum$ <> "")
    Else
        PathExists = False
    End If
End Function

Function FileExists(ByVal f$) As Boolean
    On Error GoTo NoFileFound
    If Trim$(f$)="" Then
        FileExists = False
    Else
        FileExists = (FileLen(f$) > 0)
    End If
    Exit Function
NoFileFound:
    FileExists = False
    Exit Function
End Function
