' TFCalcMatl.bas for FilmStar INDEX 32-bit
' Copyright 2003-2010 FTG Software Associates
'
'    11.23.2003...Initial version
'    08.02.2010...Revised
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Imports TFCalc materials files from disk
'
Option Explicit
Option Base 1
DefInt i-N
DefSng A-H, O-Z
Const Title$ = "TFCalc Materials"

Sub Main()
    Dim i, j, k, nIndx, f$, file$, dum$, s$, xdum, fmt, vers
    Dim Path$, fName$
    On Error GoTo DiskErr
    Path$ = IniString("TFCalc", "MatlPath")
    If Path$ = "" Then Path$ = "c:\TFCalc\MATERIAL"
    file$ = GetFilePath$(, "mat", Path$, "Open TFCalc Materials File", 1)
    If file$= "" Then
    	End
    Else
        FilePath file$, Path$, fName$
        IndexName = fName$   ' assign file name
	End If
    Open file$ For Input As #1
    Line Input #1, s$               ' VERSION*1*
    Parse s$, dum$, xdum, "*"
    Parse s$, dum$, vers, "*"
    If vers = 1 Then
        Line Input #1, s$           ' FORMAT*1*
        Parse s$, dum$, xdum, "*"
        Parse s$, dum$, fmt, "*"
        If fmt = 1 Then
            Line Input #1, s$       ' POINTS*20*
            Parse s$, dum$, xdum, "*"
            Parse s$, dum$, nIndx, "*"
            ReDim xIndx(nIndx, 3)
            For k = 1 To nIndx
                Line Input #1, s$       ' DATA1*1*380.0*2.55*0.0* etc
                Parse s$, dum$, xdum, "*"
                Parse s$, dum$, xdum, "*"
                For j = 1 To 3
                    Parse s$, dum$, xIndx(k, j), "*"
                Next j
            Next k
            nkTable = xIndx     ' converts macro xIndx(*, 3) to program variables
            If nIndx > 0 Then
                AutoAxes
            Else
                MsgBox "No data points", vbExclamation, Title$
            End If
        Else
            MsgBox "Incompatible format - contact FTG Software", vbCritical, Title$
        End If
    Else
        MsgBox "Incompatible file version - contact FTG Software", vbCritical, Title$
    End If
    Close
    WriteIniString "TFCalc", "MatlPath", Path$  ' save current TFCalc path
    MainActivate
    SendKeys "{F12}"  ' Save As prompt
    Exit Sub
DiskErr:    ' hitting cancel gets you here
    Close
End Sub

Sub Parse (strin$, strout$, xout As Variant, ByVal delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub

Sub FilePath(ByVal f$, Path$, fNam$)
    Dim k, r$
    k = InStr(f$, "\")
    If k = 0 Then
        k = InStr(f$, ":")
        If k = 0 Then
            Path$ = ""
            fNam$ = f$
        Else
            Path$ = Mid$(f$, 1, 2)
            fNam$ = Mid$(f$, 3)
        End If
    Else
        k = InStrRev(f$, "\")   ' first occurence of \ from end of string
        Path$ = Mid$(f$, 1, k - 1)
        fNam$ = StripExt$(Mid$(f$, k + 1))
    End If
End Sub

Function StripExt$(ByVal t$)    ' strip off file extension
    On Error Resume Next        ' cannot just search for "." in long file name
    If InStr(t$, ".") = 0 Then
        StripExt$ = t$      ' no extension
    Else
        StripExt$ = Left$(t$, InStrRev(t$, ".") - 1)
    End If
End Function
