' TolerEnvl.bas for FilmStar DESIGN
' Copyright 2012 FTG Software Associates
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
' Computes Min/Max envelopes for random layer errors
' Set errors in Evaluate..Tolerancing..Values <Ctrl+N>

Option Explicit
Option Base 1
DefLng i-n
DefSng A-H, O-Z

' *************** Change as required ***************
Const kT = 2        ' 1 Reflectance, 2 Transmittance
Const nIter = 5000  ' # of iterations
' **************************************************

Dim nDat, yMin(), yMax(), xDat()

Sub Main
    Dim i
    CalcRandSeed 5  ' optional - get same errors each time
    PlotClose
    AxesDraw: CalcPlot
    xDat = Spectrum_X: nDat = UBound(xDat)
    ReDim yMin(nDat, 2), yMax(nDat, 2)
    For i = 1 To nDat
        yMin(i, kT) = 10000: yMax(i, kT) = -10000
    Next i
    StatusLabel "Iteration 1/" & CStr(nIter)
    For i = 1 To nIter
        If i Mod 50 = 0 Then StatusLabel "Iteration " & CStr(i) & "/" & CStr(nIter)
        DoCalc
    Next i
    PlotLegendOn True
    PlotLegend(1) = "Min": PlotLegend(2) = "Max": PlotLegend(3) = "Design"
    PlotActivate
    Spectrum_Y = yMin   ' min envelope
    PlotNext
    Spectrum_Y = yMax   ' max envelope
    PlotNext
    CalcPlot    ' calculate original design
    PlotNext
End Sub

Sub DoCalc()
    Dim i, yDat()
    CalcRand
    yDat = Spectrum_Y
    For i = 1 To nDat
        If yDat(i, kT) < yMin(i, kT) Then yMin(i, kT) = yDat(i, kT)
        If yDat(i, kT) > yMax(i, kT) Then yMax(i, kT) = yDat(i, kT)
    Next i
End Sub
