' WaveShow.bas for FilmStar MEASURE 32-bit
' Copyright 2001 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program shows how to mark up a spectrum showing performance at
' selected wavelengths.
'
' To use this program, first scan a spectrum or load one from disk.
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   Show Wavelengths
'   Command       basrun c:\winfilm\basic32\waveshow.bas;

Option Explicit
DefInt I-N
DefSng a-H, O-Z
Dim xData(), yData(), kData, a$

Sub Main
    Dim Wave, WaveList$, dum$
    xData = Spectrum_X      ' get spectrum from MEASURE
    yData = Spectrum_Y
    On Error GoTo NoData
    kData = UBound(xData)
    WaveList = IniString("WaveShow", "List")
    Begin Dialog UserDialog 435,99,"Auto Wavelength Annotations" ' %GRID:5,3,1,1
        Text 35,12,305,15,"Wavelength List (comma separated)",.Text1
        TextBox 30,27,375,21,.txtList
        OKButton 115,63,90,24
        CancelButton 235,63,90,24
    End Dialog
    On Error GoTo MainBye
    Dim dlg As UserDialog
    dlg.txtList = WaveList
    Dialog dlg
    WaveList = Trim$(dlg.txtList)
    WriteIniString("WaveShow", "List", WaveList)
    Do Until WaveList = ""
        Parse WaveList, dum$, Wave, ","
        AddAnnot Wave
    Loop
    PlotClose
    PlotAnnotation = a$
    PlotAnnotate True   ' must be before PlotActivate
    PlotActivate
    PlotNext
    End
NoData:
    MsgBox "No spectrum in memory", vbCritical, "Error"
MainBye:
    End
End Sub

Sub AddAnnot(ByVal w)
    Dim i, j, y
    For i=1 To kData
        If xData(i) = w Then
            y = yData(i)
            Exit For
        ElseIf xData(i) > w Then    ' need to interpolate
            y = yData(i-1) + (yData(i)-yData(i-1))*(w-xData(i-1))/((xData(i)-xData(i-1)))
            Exit For
        End If
    Next i
    If y > 0 Then
        a$ = a$ & "vline" & Str(w) & ",0,|t  " & Format$(w, "0.0#") & ",9;0" & vbCrLf
        a$ = a$ & "graph" & Str(w) & "," & Trim$(Str(100*y)) & ",1," & Format$(100*y, "0.00#") & "%,9;0" & vbCrLf
    End If
End Sub

Sub Parse (strin$, strout$, xout As Single, delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub

